﻿
console.log("JS called");
var width=250, //should not be changed
	height=200, //can be changed
	margin_top=10,
	margin_bottom=10;


	//load blog details for use in webservice calls
	var variable_1 = 0;	
	var variable_2 = 0;
	var blog_id=0;
	variable_1 = document.getElementById("storage").getAttribute("data-variable-one"); //get blog id
	blog_id = document.getElementById("storage").getAttribute("data-variable-two"); //get blog_name
	blog_id=16; // just for testing, delete later!!!
	console.log("JS:", variable_1, variable_2);


var mainlink="https://restapi20190624033927.azurewebsites.net/api"; //core part of the webservice link 
var codestring="?code=7XMT2o8rqHbaViy2geq9X4rYFwI5xYnNav1bGFcchdlBhKXR5PvcDA=="	//webservice code, append to end of link
var channelSelection=document.getElementById('selectElement').value;
var date_rect;
var boxplot_date=startdate;

var rectdate=null;
var intervall=7; 
var urlformat=d3.timeFormat("%Y%d%m");
var urlformatsankey=d3.timeFormat("%Y%m%d");

var treeData;
var measurepoints;
var testglobal="global"

// A recursive helper function for performing some setup by walking through all nodes
function visit(parent, visitFn, childrenFn) {
	if (!parent) return;
	
	visitFn(parent);
	
	var children = childrenFn(parent);
	if (children) {
		var count = children.length;
		for (var i = 0; i < count; i++) {
			visit(children[i], visitFn, childrenFn);
		}
	}
}

//some formats
var DE = d3.timeFormatDefaultLocale({
    "decimal": ",",
    "thousands": ".",
    "grouping": [3],
    "currency": ["", "€"],
    "dateTime": "%a %b %e %X %Y",
    "date": "%m/%d/%Y",
    "time": "%H:%M:%S",
    "periods": ["AM", "PM"],
    "days": ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
    "shortDays": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
    "months": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
    "shortMonths": ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
    });

var localeGerman = d3.formatLocale({
	"decimal": ",",
	"thousands": ".",
	"grouping": [3],
	"currency": ["€", ""] //if you want a space between €-sign and number, add it here in the first string 
	});
  	  

//formats
var timeFormat = d3.timeFormat('%Y-%m-%dT%X');
var monthDayFormat = d3.timeFormat('%d.%m');
var hourFormat = d3.timeFormat('%H');
var daytimeFormat=d3.timeFormat('%d.%m.%Y %H:%M:%S');
var clockFormat=d3.timeFormat('%H:%M');
var numberFormat=d3.format(",.3f");
var numberFormatDE=localeGerman.format(",.3f");
var monthpickerFormat=d3.timeFormat('%Y-%m');
    
var doneloading=false;

var Nodecount=0;
var measure_point_cnt=0;
var measure_point_list=[];
var measure_point_names=[];
var Nodenamelist=[];
var NodeIDlist=[]


loadtree();

//var blog_id = "2"; //get blog id from wordpress
var today=new Date();
var startdate;

var selectElement = document.getElementById('selectElement');

/*
for(var i=0;i<Nodecount;i++){

  var option = document.createElement('option');
  option.text = NodeIDlist[i]+' '+ Nodenamelist[i];
  option.value = NodeIDlist[i];
  selectElement.options[i] = option;
}
*/
/*
selectElement.onchange = function(){
  console.log(" Node change!!!");
  loadtree();
  
}
*/

//Initialize the View by loading thresholds, the heatmap and the boxplot
function initView(){
	channelSelection=document.getElementById('selectElement').value;
	kanalAuswahl=channelSelection;
	console.log(channelSelection);
	startdate=new Date((today.getMonth()+1)+"/01/"+today.getFullYear());
	var currentdate=new Date();
	document.querySelector('input[type="month"]').value=monthpickerFormat(currentdate);
	document.getElementById('nValue_y').value=String(startdate.getFullYear());
	document.getElementById('nValue_m').value=startdate.getMonth()+1;
	//startdate=new Date("01."+document.getElementById('nValue_m').value+"."+document.getElementById('nValue_y').value);
	console.log(startdate.getMonth()+1);
	//startdate=urlformat(startdate);
	createboxplot(channelSelection,startdate,intervall);
	getThresholds(channelSelection);
	createheatmap(startdate.getMonth()+1, startdate.getFullYear())
}

//Update the channnel selection options
function updateOptions(){
	for(var i=0;i<measure_point_cnt;i++){

		var option = document.createElement('option');
		option.text = measure_point_list[i]+' '+ measure_point_names[i];
		option.value = measure_point_list[i];
		selectElement.options[i] = option;
	}

	initView();
}

//get all channels with id and name
d3.json(mainlink+"/Messstellen/"+blog_id.toString()+codestring).then(function(sdata){
//d3.json("https://functionapp120190517060515.azurewebsites.net/api/Messstellen").then(function(sdata){

	testglobal="local";
	measurepoints=sdata;
	measurepoints.forEach(function(obj) { 
		measure_point_cnt++;
		measure_point_list.push(obj.Messstelle);
		measure_point_names.push(obj.Bezeichnung)	

	});
updateOptions();
}).catch(function(error){
	console.log("Failed to load measureplaces.")
});





function getThresholds(kanalAuswahl){ // get thresholds for channel from database	  

		var url_thresholds=mainlink+"/Grenzwerte/";	
		var mythresholds=d3.json(url_thresholds+blog_id.toString()+"/"+kanalAuswahl+"/1"+codestring);		
			
		mythresholds.then(function(data){  
			//return
				//write threshold-values from database in input-fields
				//document.getElementById('nValue_monday').value=threshold_monday; 
				document.getElementById('nValue_monday').value=data[0].value_monday; 
				document.getElementById('nValue_tuesday').value=data[0].value_tuesday;
				document.getElementById('nValue_wednesday').value=data[0].value_wednesday; 
				document.getElementById('nValue_thursday').value=data[0].value_thursday;
				document.getElementById('nValue_friday').value=data[0].value_friday;
				document.getElementById('nValue_saturday').value=data[0].value_saturday;
				document.getElementById('nValue_sunday').value=data[0].value_sunday; 
				
		}).catch(function(error){
			console.log("Loading Thresholds failed."+error);
		});  
}



//load the tree
function loadtree(){
	Nodecount=0;
	NodeIDlist=[];
	Nodenamelist=[];
	var nodesel = document.getElementById('selectElement').value;
	console.log("treedata laden Node:"+nodesel);
	//d3.json("https://managee2.azurewebsites.net/wp-content/mE/Postel/Postel_treedata.php", function(sdata){  //change these to database confi if possible
	d3.json(mainlink+"/TreeData/"+blog_id.toString()+codestring).then(function(sdata){
		//treeData = sdata;	

			testglobal="local";
			treeData=sdata;
			visit(treeData, function(d) {
				Nodecount++;
				NodeIDlist.push(d.NodeID);
				Nodenamelist.push(d.name)
				//axLabelLength = opts.maxLabelLength || Math.max(d.name.length, maxLabelLength);	
				}, function(d) {
				return d.children && d.children.length > 0 ? d.children : null;
			});

		doneloading=true;
		});
}



//evaluate the intervall selection 
if(document.getElementById('intyear').checked){
	intervall=8;
}
if(document.getElementById('intmonth').checked){
	intervall=7;
}
if(document.getElementById('intweek').checked){
	intervall=6;
}
if(document.getElementById('intday').checked){
	intervall=5;
}



document.getElementById('nValue_m').onchange=function(){
	var cmon = document.getElementById('nValue_m').value
	var cyear = document.getElementById('nValue_y').value
	if (cmon << 10){
		cmon = "0"+cmon;
	}
	startdate=new Date(cmon+"/01/"+cyear);
	refreshboxplot(channelSelection,startdate,intervall);
	createheatmap(cmon,cyear,true);
}

document.getElementById('nValue_y').onchange=function(){
	var cmon = document.getElementById('nValue_m').value
	var cyear = document.getElementById('nValue_y').value
	if (cmon << 10){
		cmon = "0"+cmon;
	}
	startdate=new Date(cmon+"/01/"+cyear);
	refreshboxplot(channelSelection,startdate,intervall) 
	createheatmap(cmon,cyear,true);
}

//channel selection changed so update the view
d3.selectAll('[name =Auswahl]').on("change", function() {		
	kanalAuswahl_alt=kanalAuswahl;		
	kanalAuswahl = this.value;	

	var mystring=document.querySelector('input[type="month"]').value;
	var mydate=new Date(mystring);
	var cmon = mydate.getMonth()+1;//document.getElementById('mycomb').value;
	var cyear = mydate.getFullYear();//document.getElementById('nValue_y').value;
	if (cmon << 10){
		cmon = "0"+cmon;
	}
	startdate=new Date(cmon+"/01/"+cyear);
	if(kanalAuswahl!=kanalAuswahl_alt){
		console.log(" Node change!!!");
		loadtree();
		channelSelection=kanalAuswahl;
		refreshboxplot(channelSelection,startdate,intervall)        
		createheatmap(cmon, cyear,true);
		getThresholds(kanalAuswahl);
		
	}				
});

//Apply intervall selection
d3.selectAll('.Intervallauswahl').on('click',function(){
						
	if(document.getElementById('intyear').checked){
		intervall=8;
	}
	if(document.getElementById('intmonth').checked){
		intervall=7;
	}
	if(document.getElementById('intweek').checked){
		intervall=6;
	}
	if(document.getElementById('intday').checked){
		intervall=5;
	}
	refreshboxplot(channelSelection,startdate,intervall)
	});


//user pressed the update button so update the view to chosen month
d3.select("#updatesel button").on("click", function(){
	console.log("update selection");
	var mystring=document.querySelector('input[type="month"]').value;
	//var mydate=monthpickerFormat.parse(mystring);
	var mydate=new Date(mystring);
	console.log(mydate+" "+mydate.getMonth());
	var cmon = mydate.getMonth()+1;//document.getElementById('mycomb').value;
	var cyear = mydate.getFullYear();//document.getElementById('nValue_y').value;
	if (cmon << 10){
		cmon = "0"+cmon;
	}
	startdate=new Date(cmon+"/01/"+cyear);
	refreshboxplot(channelSelection,startdate,intervall) 
	createheatmap(cmon,cyear,true);


});

	//Button for Saving Values in Database
	d3.select("#sthresholds button").on("click", function() {
		saveThresholds(kanalAuswahl);			
	});

	d3.select("#updatehm button").on("click", function() {
		renderColor();
	});


//save thresholds in database by calling the webservice
function saveThresholds(kanalAuswahl){
	
	//var save_url="http://40.68.165.11/api/Messstellen/Grenzwerte/"+kanalAuswahl+"/1/";
		//var save_url="http://managee2.azurewebsites.net/wp-content/mE/heatmap/minmax.php?mode=1";
	var save_url=mainlink+"/GrenzwerteSetzen/"+blog_id.toString()+"/"+kanalAuswahl+"/1/";
	
	threshold_monday = nValue_monday.value;
	threshold_tuesday = nValue_tuesday.value;
	threshold_wednesday = nValue_wednesday.value;
	threshold_thursday = nValue_thursday.value;
	threshold_friday = nValue_friday.value;
	threshold_saturday = nValue_saturday.value;
	threshold_sunday = nValue_sunday.value; 		
	//save_url=save_url+threshold_monday+"/"+threshold_tuesday+"/"+threshold_wednesday+"/"+threshold_thursday+"/"+threshold_friday+"/"+threshold_saturday+"/"+threshold_sunday;
	save_url=save_url+threshold_sunday+"/"+threshold_monday+"/"+threshold_tuesday+"/"+threshold_wednesday+"/"+threshold_thursday+"/"+threshold_friday+"/"+threshold_saturday+codestring;
	console.log(save_url);
	d3.json(save_url).then(function(data){console.log(data);})
	}


var tzone = (new Date().getTimezoneOffset())/60; //Zeitzone in h
console.log("Zeitzone: "+tzone);      

var box_data=null;

//refresh the boxplot after time or channel selection changed 
function refreshboxplot(channelSelection,startdate,intervall){
	var url1= "https://restapi20190624033927.azurewebsites.net/api/StatistikVerbraucher/"+blog_id.toString()+"/";
	var date_string=urlformatsankey(startdate);
  //var url1= "http://managee2.azurewebsites.net/wp-content/mE/heatmap/boxplot.php?NodeID="+channelSelection+"&int="+intervall+"&date="+startdate+"&tzone="+tzone*-1;
	console.log(url1+intervall+"/"+channelSelection+"/"+date_string+codestring);
	d3.json(url1+intervall+"/"+channelSelection+"/"+date_string+codestring).then(function(json){
            box_data=json;
        
        var yScale=d3.scaleLinear()
            .domain([box_data[0].WirkleistungMaximal, box_data[0].WirkleistungMinimal])
            .range([margin_bottom, height-margin_top]);
                        
        var sum=0;
        var median=box_data[0].WirkleistungMittelwertArith;
        var mindata=box_data[0].WirkleistungMinimal;
        var maxdata=box_data[0].WirkleistungMaximal;
        var zeitmin=box_data[0].MessungBezeichnung +" "+ box_data[0].ZeitpunktMinimalUTC;
        var zeitmax=box_data[0].MessungBezeichnung +" "+ box_data[0].ZeitpunktMaximalUTC;

        var dates=[];//dates of min and max
        dates[0]=zeitmin;
        dates[1]=zeitmax;

        box=d3.select(".boxplot");

		line_xcoord=width*0.45;
		box.data(box_data)
			.attr('width', width)
			.attr('height', height+20);

        //refresh max
        d3.select("#max_kw")
            .transition()    
            .attr('y', yScale(maxdata))
            .text("Max "+numberFormatDE(maxdata/1000) +"kW");
        d3.select("#max_time")
            .transition()
            .attr('y', yScale(maxdata))
            .text(box_data[0].ZeitpunktMaximalUTC)
        d3.select("#max_desc")
            .transition()
            .attr('y', yScale(maxdata))
            .text(box_data[0].MessungBezeichnung)
          //refresh min
        d3.select("#min_kw")
            .transition()    
            .attr('y', yScale(mindata))
            .text("Min "+numberFormatDE(mindata/1000) +"kW");
        d3.select("#min_time")
            .transition()
            .attr('y', yScale(mindata))
            .text(box_data[0].ZeitpunktMinimalUTC)
        d3.select("#min_desc")
            .transition()
            .attr('y', yScale(mindata))
            .text(box_data[0].MessungBezeichnung)
        //refresh median
        d3.select("#med_kw")
            .transition()
            .attr('y',yScale(median))
            .text("Med  "+numberFormatDE(median/1000)+"kW");


        //refresh the boxplot lines    
        d3.select("#yline")
            .transition()
            //.attr("x1", line_xcoord)
			.attr("y1", 0+margin_top)
			//.attr("x2", line_xcoord)
            .attr("y2", height-margin_bottom);
        
        d3.select("#x1line")
            .transition()
            //.attr("x1", line_xcoord-10)
			.attr("y1", yScale(mindata))
			//.attr("x2", line_xcoord+10)
            .attr("y2", yScale(mindata));
        
		//d3.select('.boxplot').selectAll('line').select('.medline').remove();
		d3.selectAll('#x2line')
			.transition()
            //.attr("x1", line_xcoord-20)
			.attr("y1", yScale(median))
			//.attr("x2", line_xcoord+10)
            .attr("y2", yScale(median));
        
        d3.select("#x3line")
            .transition()
            //.attr("x1", line_xcoord-10)
			.attr("y1", yScale(maxdata))
			//.attr("x2", line_xcoord+10)
            .attr("y2", yScale(maxdata));
        
	});
	
	d3.selectAll('line')
	.attr('class','boxplot_line');
	//.attr('id', 'box_line');
}

var box;
//create the boxplot when website when the view is called
function createboxplot(channelSelection,startdate,intervall){
	console.log("Startdate: "+startdate);
	var startdate_string="";
	var date_string=urlformatsankey(startdate);
	var data=null;					
	//var url1="http://40.68.165.11/api/StatistikVerbraucher"; //Web-Service
	//var url1= "http://managee2.azurewebsites.net/wp-content/mE/heatmap/Statistik.txt";
  	var url1= mainlink+"/StatistikVerbraucher/"+blog_id.toString()+"/";
  	//var url1= "http://managee2.azurewebsites.net/wp-content/mE/heatmap/boxplot.php?NodeID="+channelSelection+"&int="+intervall+"&date="+startdate+"&tzone="+tzone*-1;
	console.log(url1+intervall+"/"+channelSelection+"/"+date_string);
	d3.json(url1+intervall+"/"+channelSelection+"/"+date_string+codestring).then(function(data){
		console.log(data);
			
		var yScale=d3.scaleLinear()
				.domain([data[0].WirkleistungMaximal, data[0].WirkleistungMinimal])
				.range([margin_bottom, height-margin_top]);
							
		var sum=0;
		var median=data[0].WirkleistungMittelwertArith;
		var mindata=data[0].WirkleistungMinimal;
		var maxdata=data[0].WirkleistungMaximal;
    	var zeitmin=data[0].MessungBezeichnung +" "+ data[0].ZeitpunktMinimalUTC;
    	var zeitmax=data[0].MessungBezeichnung +" "+ data[0].ZeitpunktMaximalUTC;
		var dates=[];//dates of min and max
		var line_xcoord=0;//Position of vertical line

		//Convert UTC Time into local Time
	//	var day=new Date();
	//	var n = day.getTimezoneOffset();	
	//	dates[0]=timeFormat.parse(data[0].ZeitpunktMinimalUTC);
	//	dates[0]=d3.time.hour.offset(dates[0],- (n/60));
	//	dates[1]=timeFormat.parse(data[0].ZeitpunktMaximalUTC);
	//	dates[1]=d3.time.hour.offset(dates[1],- (n/60));
   
    dates[0]=zeitmin;
    dates[1]=zeitmax;

		box=d3.select(".boxplot");
		line_xcoord=width*0.45;
		d3.select(".boxplot")
			.data(data)
			.attr('width', width)
			.attr('height', height+20);
			//.style('background', '#FFFFFF');
			
		//Maximum
		d3.select(".boxplot").append('text')
			.attr('x',line_xcoord-15)
            .attr('y', yScale(maxdata))
            .attr('id', 'max_kw')
			.style('text-anchor','end')
			.text("Max "+numberFormatDE(maxdata/1000) +"kW");
		box.append('text')
			.attr('x',line_xcoord+15)
            .attr('y', yScale(maxdata))
            .attr('id','max_time')
    		.style('alignment-baseline', 'ideographic')
        	.attr('dy', "0em")
        	.text(data[0].ZeitpunktMaximalUTC)
       	box.append('text')
			.attr('x',line_xcoord+15)
            .attr('y', yScale(maxdata))
            .attr('id', 'max_desc')
    		.style('alignment-baseline', 'central')
    		.attr('dy', "1em")
        	.text(data[0].MessungBezeichnung)
    
			
		//Minimum	
		d3.select(".boxplot").append('text')
			.attr('x',line_xcoord-15)
            .attr('y', yScale(mindata))
            .attr('id', 'min_kw')
			.style('text-anchor','end')
			.text("Min "+numberFormatDE(mindata/1000) +"kW");
		box.append('text')
			.attr('x',line_xcoord+15)
            .attr('y', yScale(mindata))
            .attr('id', 'min_time')
    		.style('alignment-baseline', 'ideographic')
        	.attr('dy', "0em")
        	.text(data[0].ZeitpunktMinimalUTC)
    	box.append('text')
			.attr('x',line_xcoord+15)
            .attr('y', yScale(mindata))
            .attr('id', 'min_desc')
    		.style('alignment-baseline', 'central')
    		.attr('dy', "1em")
        	.text(data[0].MessungBezeichnung)
    
			//.text(monthDayFormat(dates[0])+" "+clockFormat(dates[0])+"Uhr")
		//Median	
		d3.select(".boxplot").append('text')
			.attr('x',line_xcoord-15)
            .attr('y', yScale(median))
            .attr('id', 'med_kw')
			.style('text-anchor','end')
			.text("Med  "+numberFormatDE(median/1000)+"kW");


		d3.select(".boxplot").selectAll('text') 
			.style('alignment-baseline','central');
			
		//vertical line	
		var yline =box.append("line")
			//.style("stroke", "black")
			.attr("x1", line_xcoord)
			.attr("y1", 0+margin_top)
			.attr("x2", line_xcoord)
            .attr("y2", height-margin_bottom)
            .attr('id', 'yline');

		//horizontal lines
		var x1line=box.append("line")
			//.style("stroke", "black")
			.attr("x1", line_xcoord-10)
			.attr("y1", yScale(mindata))
			.attr("x2", line_xcoord+10)
            .attr("y2", yScale(mindata))
            .attr('id', 'x1line');

		var x2line=d3.select(".boxplot").append("line")
			//.style("stroke", "black")
			.attr("x1", line_xcoord-10)
			.attr("y1", yScale(median))
			.attr("x2", line_xcoord+10)
            .attr("y2", yScale(median))
			.attr('id', 'x2line')
			.attr('class', "medline");
			

		var x3line=box.append("line")
			//.style("stroke", "black")
			.attr("x1", line_xcoord-10)
			.attr("y1", yScale(maxdata))
			.attr("x2", line_xcoord+10)
            .attr("y2", yScale(maxdata))
            .attr('id', 'x3line');
			



		//style for boxplot lines   	
        d3.select(".boxplot").selectAll('text')
			.attr('class','boxplot_text');
    
		d3.selectAll('line')
			.attr('class','boxplot_line');
    		//.attr('id', 'box_line');
		
	});

}


var average=0;
var dataread=0;
var zuordnungSID = [0,0,3,7,62,66,71,75,79,83,87,92,96,100,104,109,113,117,121,125,129];
var sankeyThresholds=[0,0];
	
	var spinopts = {
		  lines: 13 // The number of lines to draw
		, length: 28 // The length of each line
		, width: 19 // The line thickness
		, radius: 42 // The radius of the inner circle
		, scale: 1 // Scales overall size of the spinner
		, corners: 1 // Corner roundness (0..1)
		, color: '#000' // #rgb or #rrggbb or array of colors
		, opacity: 0.25 // Opacity of the lines
		, rotate: 0 // The rotation offset
		, direction: 1 // 1: clockwise, -1: counterclockwise
		, speed: 1 // Rounds per second
		, trail: 60 // Afterglow percentage
		, fps: 20 // Frames per second when using setTimeout() as a fallback for CSS
		, zIndex: 2e9 // The z-index (defaults to 2000000000)
		, className: 'spinner' // The CSS class to assign to the spinner
		, top: '100%' // Top position relative to parent
		, left: '50%' // Left position relative to parent
		, shadow: false // Whether to render a shadow
		, hwaccel: false // Whether to use hardware acceleration
		//, position: 'absolute' // Element positioning
		, position: 'relative' // Element positioning
    }
	 
	 
	var monthSelection = nValue_m.value, //selected Month
		yearSelection=nValue_y.value,	//selected Year
		monthSelection_old=nValue_m.value, //selected Month, before new Input
		yearSelection_old=nValue_y.value, //selected Year, before new Input
		kanalAuswahl=1, //channel selection
		kanalAuswahl_alt=1; //channel selection, before input
		var abfrage="https://managee2.azurewebsites.net/wp-content/themes/twentyfourteen_mE_ipTro/d3_stuff/Heatmap/Heatmap_kwh_Abfrage.php?kanal="; //address of php-script
		var url_kwh="";
	//variables for daily thresholds	
	var threshold_monday=0,
		threshold_tuesday=0,
		threshold_wednesday=0,
		threshold_thursday=0,
		threshold_friday=0,
		threshold_saturday=0,
		threshold_sunday=0;
  
	var hourFormat = d3.timeFormat('%H'),
		dayFormat = d3.timeFormat('%j'),
		timeFormat = d3.timeFormat('%Y-%m-%dT%X'),
		monthDayFormat = d3.timeFormat('%m.%d');
		dayMonthFormat=d3.timeFormat('%d.%m'),
		weekdayFormat = d3.timeFormat('%a');
		weekFormat = d3.timeFormat('%W');
		yearFormat = d3.timeFormat('%Y');
		monthFormat= d3.timeFormat('%m');
		dayofyearFormat=d3.timeFormat('%j');
		milliseconds=0;	
  
        
function toggleDiv(element){
	if(document.getElementById(element).style.display == 'none'){
		document.getElementById(element).style.display = 'block';
		newdata = 1;
	}
	else{
		document.getElementById(element).style.display = 'none';
	}
}

document.getElementById('chart').style.display = 'none';   //Sankey ausblenden

var dayOffset=0;

var heatmap=null;
//change the colors of the heatmap according to the defined thresholds
function renderColor(){
	
	//values in Input fields
	threshold_monday = nValue_monday.value;
	threshold_tuesday = nValue_tuesday.value;
	threshold_wednesday = nValue_wednesday.value;
	threshold_thursday = nValue_thursday.value;
	threshold_friday = nValue_friday.value;
	threshold_saturday = nValue_saturday.value;
	threshold_sunday = nValue_sunday.value;
	 
    heatmap.selectAll('rect')
		.filter(function(d){
			return (d.value>=0);
		})
		.transition()
		.delay(function(d){      
			return (dayFormat(d.date)-dayOffset)*15;
		})
		
		.duration(500)
		.attr('class',function(d){
			//value is smaller than threshold   
			if( d.value<threshold_monday && weekdayFormat(d.date)=='Mon'){
				return 'under';
			}
			else if( d.value<threshold_tuesday && weekdayFormat(d.date)=='Tue'){
				return 'under';
			}
			else if( d.value<threshold_wednesday && weekdayFormat(d.date)=='Wed'){
				return 'under';
			}
			else if( d.value<threshold_thursday && weekdayFormat(d.date)=='Thu'){
				return 'under';
			}
			else if( d.value<threshold_friday && weekdayFormat(d.date)=='Fri'){
				return 'under';
			}
			else if( d.value<threshold_saturday && weekdayFormat(d.date)=='Sat'){
				return 'under';
			}
			else if( d.value<threshold_sunday && weekdayFormat(d.date)=='Sun'){
				return 'under';
			}else{ return 'above';}			
	   });
       	   	  
  }

//get the dates for the webservice link, start one month before selection and end one month after selection
//to be sure, that all relevant data is loaded
//may be optimised to 1/2 month before and after 
function getWebServiceIntervalHeatmap(monthSelection, yearSelection){
	var queryInterval=new Object(); 
	
	if(monthSelection==1){
		queryInterval["startyear"]=yearSelection*1-1;
		queryInterval["startmonth"]=12;
		queryInterval["endyear"]=yearSelection;
		queryInterval["endmonth"]=monthSelection*1+1;
	}
	else if(monthSelection==12){
		queryInterval["startyear"]=yearSelection;
		queryInterval["startmonth"]=monthSelection-1;
		queryInterval["endyear"]=yearSelection*1+1;
		queryInterval["endmonth"]=1;
	}
	else{
		queryInterval["startyear"]=yearSelection;
		queryInterval["startmonth"]=monthSelection*1-1;
		queryInterval["endyear"]=yearSelection;
		queryInterval["endmonth"]=monthSelection*1+1;

	}
	return queryInterval; 
}  

function daysInMonth (month, year) {
    return new Date(year, month, 0).getDate();
}
//create or refresh the heatmap. Default is create (refresh=false)
function createheatmap(monthSelection, yearSelection, refresh=false){
    
    var target = document.getElementById('spin')
    var spinner = new Spinner(spinopts).spin(target); 
    //var target1 = document.getElementById('spin1')
    //var spinner1 = new Spinner(spinopts).spin(target);
    var lowestweek=52;	
	var abfrageurl=abfrage+kanalAuswahl;
	
	//get the interval for the webservice link
	var queryInterval=getWebServiceIntervalHeatmap(monthSelection, yearSelection);
	var startstring=queryInterval.startyear.toString()+queryInterval.startmonth.toString().padStart(2,'0')+"01";
	console.log(queryInterval.endmonth);
	console.log(daysInMonth(queryInterval.endmonth,queryInterval.endyear));
	var endstring=queryInterval.endyear.toString()+queryInterval.endmonth.toString().padStart(2,'0')+daysInMonth(queryInterval.endmonth,queryInterval.endyear);
	console.log(startstring);
	console.log(endstring);
    //console.log(abfrageurl);

    var sum = 0;
    var counter =0;
    //sums and counters for calculating median
    var	summonday=0,
        cntmonday=0,
        sumtuesday=0,
        cnttuesday=0,
        sumwednesday=0,
        cntwednesday=0,
        sumthursday=0,
        cntthursday=0,
        sumfriday=0,
        cntfriday=0,
        sumsaturday=0,
        cntsaturday=0,
        sumsunday=0,
        cntsunday=0;
			
	
	var datafound=0; // 
	
    //UI configuration
    var itemSize = 50, //size rects
        cellSize = itemSize-2.7,
        width = 390,// 800
        height = 400,
        margin = {top:20,right:20,bottom:20,left:40},
        color1='#5eff63'// color for values under threshold
        color2='#e20613'//color for values over threshold

    //formats
    var hourFormat = d3.timeFormat('%H'),
        dayFormat = d3.timeFormat('%j'),
        timeFormat = d3.timeFormat('%Y-%m-%dT%X'),
        monthDayFormat = d3.timeFormat('%m.%d');
        dayMonthFormat=d3.timeFormat('%d.%m'),
        weekdayFormat = d3.timeFormat('%a');
		weekFormat = d3.timeFormat('%W');
        yearFormat = d3.timeFormat('%Y');
        monthFormat= d3.timeFormat('%m');
        dayofyearFormat=d3.timeFormat('%j');
		milliseconds=0;
		weekTickFormat=d3.timeFormat('%V');

        var DE = d3.timeFormatDefaultLocale({
            "decimal": ",",
            "thousands": ".",
            "grouping": [3],
            "currency": ["", "€"],
            "dateTime": "%a %b %e %X %Y",
            "date": "%m/%d/%Y",
            "time": "%H:%M:%S",
            "periods": ["AM", "PM"],
            "days": ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
            "shortDays": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
            "months": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
            "shortMonths": ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
	});
	
	var numberFormatDE2=localeGerman.format(",.1f");
	
  	//data vars for rendering
  	var dateExtent = null,
		dateExtent2=null,
    	data = null,
    
    colorCalibration = ['#f6faaa','#FEE08B','#FDAE61','#F46D43','#D53E4F','#9E0142'],
    dailyValueExtent = {};
	weekOffset =0;
	weeklyValueExtent =0;
	

  	//axises and scales
  	var axisWidth = itemSize*5 ,
    	axisHeight = itemSize*6,
    	xAxisScale = d3.scaleTime(),
    	xAxis =d3.axisTop()
	 	 .ticks(d3.timeMonday)
	  	//.ticks(d3.timeMondayOfYear)
	 	 .tickFormat(weekTickFormat),
	 
	 	yearAxis=d3.axisTop()
		.ticks(d3.timeMonday)
		.tickFormat(weekFormat),
	  
    yAxisScale = d3.scaleLinear()
      .range([0,axisHeight])
      .domain([1,7]), // 7 Days/Week
    yAxis = d3.axisRight()
       //.attr("x", itemSize*5)
      .ticks(7)
	  .tickFormat(d3.format('02d'))
      .scale(yAxisScale);

	//Start of Timeframe for Sankey	
	var Tag0=1,
		Monat0=1,
		Jahr0=2017;
		
	//take values still in inputfield // delete?
	threshold_monday = nValue_monday.value;
	threshold_tuesday = nValue_tuesday.value;
	threshold_wednesday = nValue_wednesday.value;
	threshold_thursday = nValue_thursday.value;
	threshold_friday = nValue_friday.value;
	threshold_saturday = nValue_saturday.value;
	threshold_sunday = nValue_sunday.value;
			
		
	var change=1;//data has changed
	var days = ["Mo", "Di", "Mi", "Do", "Fr", "Sa", "So"];
    var svg = d3.select('[role="heatmap"]');
    heatmap = svg
    	.attr('width',width)
    	.attr('height',height)
  	.append('g')
    	.attr('width',width-margin.left-margin.right)
    	.attr('height',height-margin.top-margin.bottom)
    	.attr('transform','translate('+margin.left+','+margin.top+')');

	//channel selection

	
	 //Read day-Data for Heatmap
	 d3.json(mainlink+"/Tageswerte/"+blog_id.toString()+"/"+kanalAuswahl+"/"+startstring+"/"+endstring+codestring).then(function(data){
	
	//d3.json("http://managee2.azurewebsites.net/wp-content/themes/twentyfourteen_mE_ipTro/d3_stuff/Heatmap/Heatmap_kwh_Abfrage.php?kanal="+kanalAuswahl).then(function(data){      
      //d3.json("http://managee2.azurewebsites.net/wp-content/mE/heatmap/heatmap_kwh.php?jr="+yearSelection+"&mon="+monthSelection+"&toff=2&Node="+kanalAuswahl,function(err,data){
      //console.log ("http://managee2.azurewebsites.net/wp-content/mE/heatmap/heatmap_kwh.php?jr="+yearSelection+"&mon="+monthSelection+"&toff=2&Node="+kanalAuswahl);
      //d3.json("http://managee2.azurewebsites.net/wp-content/mE/heatmap/heatmaptestdata2.txt",function(err,data){
	console.log(mainlink+"/Tageswerte/"+blog_id.toString()+"/"+kanalAuswahl+"/"+startstring+"/"+endstring+codestring);
	console.log(data);  
	//data = data.data;
    data.forEach(function(valueObj){
		//var parseTime=d3.timeParse("%Y-%m-%dT%H:%M:%S");
		var parseTime=d3.timeParse("%Y-%m-%d");
		valueObj['date'] = parseTime(valueObj['date']);	  	  
    });

    var data_filtered=[];
    data.forEach(function(element){
        if(Number(monthFormat(element.date))== monthSelection && yearFormat(element.date)==yearSelection){
            data_filtered.push(element);
        }
    });


    console.log(data_filtered);
	dateExtent2=d3.extent(data,function(d){	//date Extent for week Offset
		if(Number(monthFormat(d.date))== monthSelection && yearFormat(d.date)==yearSelection){
			datafound=1;
			if(Number(weekFormat(d.date))<=lowestweek){
				lowestweek=Number(weekFormat(d.date));			
			}				
			return d.date;	
		}
	});
	
	console.log("lowest:"+lowestweek);
	var monfound=0;
	var cnt_days=0;
			
	if(datafound==0){
		spinner.stop();
		window.alert("Keine Daten im gewählten Monat. Bitte einen anderen Monat wählen");
	}	
	
	
	
	if(lowestweek !=0){ 
		monfound=0;
		dateExtent = d3.extent(data,function(d){
			
			if( Number(yearFormat(d.date))==yearSelection && Number(weekFormat(d.date))==lowestweek && weekdayFormat(d.date)=='Mon'){
				monfound=1;
				return d.date;
			}
			
			if(monfound==0 && Number(weekFormat(d.date))==lowestweek && Number(yearFormat(d.date))==yearSelection ){ //here time could be saved, when dummydate gets calc. just once				
				milliseconds=+d.date
				//create dummydates so  the week axis gets calculated correctly
				if(weekdayFormat(d.date)=='Sun'){
					milliseconds=milliseconds-6*86400000; 
				}
				if(weekdayFormat(d.date)=='Sat'){
					milliseconds=milliseconds-5*86400000; 
				}
				if(weekdayFormat(d.date)=='Fri'){
					milliseconds=milliseconds-4*86400000; 
				}
				if(weekdayFormat(d.date)=='Thu'){
					milliseconds=milliseconds-3*86400000; 
				}
				if(weekdayFormat(d.date)=='Wed'){
					milliseconds=milliseconds-2*86400000; 
				}
				if(weekdayFormat(d.date)=='Tue'){
					milliseconds=milliseconds-1*86400000; 
				}
				if(weekdayFormat(d.date)=='Mon'){
					milliseconds=milliseconds;
				}									
				var dummydate= new Date(milliseconds); 
				return dummydate;
			}
			
			if(Number(monthFormat(d.date))== monthSelection && yearFormat(d.date)==yearSelection){
				if(weekdayFormat(d.date)=='Mon'){			
					return d.date;
				}
			} 
		});
	}else{
		dateExtent = d3.extent(data,function(d){
		if(Number(monthFormat(d.date))== monthSelection && yearFormat(d.date)==yearSelection && Number(weekFormat(d.date))==lowestweek && weekdayFormat(d.date)=='Mon' ){
				monfound=1;
				return d.date;
		}
		if(monfound==0 && Number(weekFormat(d.date))==lowestweek && Number(yearFormat(d.date))==yearSelection ){ //here time could be saved, when dummydate gets calc. just once				
			milliseconds=+d.date
			//create dummydates so  the week axis gets calculated correctly
			if(weekdayFormat(d.date)=='Sun'){
				milliseconds=milliseconds-6*86400000; 
			}
			if(weekdayFormat(d.date)=='Sat'){
				milliseconds=milliseconds-5*86400000; 
			}
			if(weekdayFormat(d.date)=='Fri'){
				milliseconds=milliseconds-4*86400000; 
			}
			if(weekdayFormat(d.date)=='Thu'){
				milliseconds=milliseconds-3*86400000; 
			}
			if(weekdayFormat(d.date)=='Wed'){
				milliseconds=milliseconds-2*86400000; 
			}
			if(weekdayFormat(d.date)=='Tue'){
				milliseconds=milliseconds-1*86400000; 
			}
			if(weekdayFormat(d.date)=='Mon'){
				milliseconds=milliseconds;
			}									
			var dummydate= new Date(milliseconds); 
			return dummydate;
		}
		if(Number(monthFormat(d.date))== monthSelection && yearFormat(d.date)==yearSelection){
			if(weekdayFormat(d.date)=='Mon'){
				console.log(d.date);			
				return d.date;
			}
		} 
		});
    }	
    
    console.log(dateExtent);
	 //render axises 
	if(lowestweek!=0){	
		axisWidth = itemSize*(weekFormat(dateExtent[1])-weekFormat(dateExtent[0]));
		xAxis.scale(xAxisScale.range([0,axisWidth]).domain([dateExtent[0],dateExtent[1]]));  
	}else{
		if(monfound==1){
			axisWidth = itemSize*(weekFormat(dateExtent[1])-weekFormat(dateExtent[0])); 
			
		}else{
			axisWidth = itemSize*(weekFormat(dateExtent[1]));//+weekFormat(dateExtent[0])); //Axis muss anders berechnet werden, weil sonst negativ
		}
		xAxis.scale(xAxisScale.range([0,axisWidth]).domain([dateExtent[0],dateExtent[1]]));  
	}
	var legendposx=axisWidth+15;
	console.log(axisWidth);
	
    if(refresh){
        //transition not working properly for the axis
        var t= d3.transition().duration(500);
        d3.select(".x")
        .transition(t)
        .attr('transform','translate('+margin.left+','+margin.top+')')
        .call(xAxis);
        d3.select(".kalender_text")
        .transition(t)
		.attr('transform','translate('+legendposx+', -9)')
		.style('fill', 'black')
		.style('text-anchor', 'start');
    }
    else{
		svg.append('g')
		.attr('transform','translate('+margin.left+','+margin.top+')')
		.attr('class','x axis')
		.call(xAxis)
		.append('text')
		.text('Kalenderwoche')
		.attr("class",'kalender_text')
		.attr('transform','translate('+legendposx+',-9)')
		.style('fill', 'black')
		.style('text-anchor', 'start');  //"date" verschieben
    }
	  /*
	  svg.append('g')
      .attr('transform','translate('+margin.left+','+margin.top+')')
      .attr('class','y axis')
      .call(yAxis)
    .append('text')
      .text('Wochentag')
      .attr('transform','translate('+legendposx+',-10)');  //"date" verschieben
    */
      dayLabels = svg.selectAll(".dayLabel")
          .data(days)
          .enter().append("text")
            .transition()
            .text(function (d) { return d; })
            .attr("x", margin.left)
            .attr("y", function (d, i) { return i * itemSize; })
            .style("text-anchor", "end")
            .attr("transform", "translate(-6," + itemSize / 1.5 + ")")
            .attr("class", function (d, i) { return ((i >= 0 && i <= 4) ? "dayLabel mono axis axis-workweek" : "dayLabel mono axis"); });
      
    dayOffset = dayFormat(dateExtent[0]);
    weekOffset= Number(weekFormat(dateExtent2[0]));


    
    if(refresh){
        svg.selectAll('rect').remove();
        u=heatmap.selectAll('rect')
            .data(data_filtered);
            u.enter().append('rect');
            u.exit().remove();

           
        heatmap.selectAll('rect')
            //.transition()
            .attr('width', function(d){
                if(Number(monthFormat(d.date))== monthSelection && yearFormat(d.date)==yearSelection){
                return cellSize;}
                    else{return 0;}})
            .attr('height',cellSize)
            .attr('x',function(d){
                if(Number(monthFormat(d.date))== monthSelection  && yearFormat(d.date)==yearSelection){				
                        return itemSize*(Number(weekFormat(d.date))-weekOffset);
                }
            })
            .attr('y',function(d){   //y-coordinate         
            //calc the position and the medians for every weekday in month
                if(Number(monthFormat(d.date))== monthSelection && yearFormat(d.date)==yearSelection){
                    
                if(weekdayFormat(d.date)=='Mon'){
                    summonday=d.value+summonday;
                    cntmonday=cntmonday+1;
                    return 0*itemSize;}
                if(weekdayFormat(d.date)=='Tue'){
                    sumtuesday=d.value+sumtuesday;
                    cnttuesday=cnttuesday+1;
                    return 1*itemSize;}
                if(weekdayFormat(d.date)=='Wed'){
                    sumwednesday=d.value+sumwednesday;
                    cntwednesday=cntwednesday+1;
                    return 2*itemSize;}
                if(weekdayFormat(d.date)=='Thu'){
                    sumthursday=d.value+sumthursday;
                    cntthursday=cntthursday+1;
                    return 3*itemSize;}
                if(weekdayFormat(d.date)=='Fri'){
                    sumfriday=d.value+sumfriday;
                    cntfriday=cntfriday+1;
                    return 4*itemSize;}
                if(weekdayFormat(d.date)=='Sat'){
                    sumsaturday=d.value+sumsaturday;
                    cntsaturday=cntsaturday+1;
                    return 5*itemSize;}
                if(weekdayFormat(d.date)=='Sun'){
                    sumsunday=d.value+sumsunday;
                    cntsunday=cntsunday+1;
                    return 6*itemSize;}
                }                              
            });
    }        
    else{
        //render heatmap rects
        heatmap.selectAll('rect')
        .data(data)
        .enter().append('rect')
        .attr('width', function(d){
            if(Number(monthFormat(d.date))== monthSelection && yearFormat(d.date)==yearSelection){
				console.log(cellSize);
				return cellSize;}
                else{return 0;}})
        .attr('height',cellSize)
        .attr('x',function(d){
            if(Number(monthFormat(d.date))== monthSelection  && yearFormat(d.date)==yearSelection){				
                    return itemSize*(Number(weekFormat(d.date))-weekOffset);
            }
        })
        .attr('y',function(d){   //y-coordinate         
        
        //calc the position and the medians for every weekday in month
            if(Number(monthFormat(d.date))== monthSelection && yearFormat(d.date)==yearSelection){
                
            if(weekdayFormat(d.date)=='Mon'){
                summonday=d.value+summonday;
                cntmonday=cntmonday+1;
                return 0*itemSize;}
            if(weekdayFormat(d.date)=='Tue'){
                sumtuesday=d.value+sumtuesday;
                cnttuesday=cnttuesday+1;
                return 1*itemSize;}
            if(weekdayFormat(d.date)=='Wed'){
                sumwednesday=d.value+sumwednesday;
                cntwednesday=cntwednesday+1;
                return 2*itemSize;}
            if(weekdayFormat(d.date)=='Thu'){
                sumthursday=d.value+sumthursday;
                cntthursday=cntthursday+1;
                return 3*itemSize;}
            if(weekdayFormat(d.date)=='Fri'){
                sumfriday=d.value+sumfriday;
                cntfriday=cntfriday+1;
                return 4*itemSize;}
            if(weekdayFormat(d.date)=='Sat'){
                sumsaturday=d.value+sumsaturday;
                cntsaturday=cntsaturday+1;
                return 5*itemSize;}
            if(weekdayFormat(d.date)=='Sun'){
                sumsunday=d.value+sumsunday;
                cntsunday=cntsunday+1;
                return 6*itemSize;}
            }    
        })
        .attr('class','default');	  
    }
	  
	  
	  
	 //open sankey when click on rect
	heatmap.selectAll('rect').on('click', function(d){
      	Tag0=d.date.getDate();
	    Monat0=monthFormat(d.date);
		Jahr0=yearFormat(d.date);
      	console.log(">>> jahr0: "+Jahr0+" monat0: "+Monat0+" tag0: "+Tag0);
		var Datum=d.date;
		var h_date=new Date(d.date)

		//startdate=urlformat(d.date);
		/*
		if(Tag0 < 10){
			Tag0 = "0"+Tag0;
		}
		//Monat0 = document.getElementById('nValue_m').value;
		if(Monat0 < 10){
			Monat0 = "0"+Monat0;
		}
		*/
		
		startdate=Tag0+"."+Monat0+"."+document.getElementById('nValue_y').value;		
		channelSelection=document.getElementById('selectElement').value;

		if(document.getElementById('intyear').checked){
				intervall=8;
			}
		if(document.getElementById('intmonth').checked){
			intervall=7;
		}
		if(document.getElementById('intweek').checked){
			intervall=6;
		}
		if(document.getElementById('intday').checked){
			intervall=5;
		}
		console.log(h_date+urlformat(h_date));
		refreshboxplot(channelSelection,h_date,intervall)
			
		var target1 = document.getElementById('spin1')
		var spinner1 = new Spinner(spinopts).spin(target1);
		showsankey(Tag0,Monat0,Jahr0,Datum);			
		console.log('click detected');
		setTimeout(function() {
			spinner1.stop();    
		}, 2000);
	 
	})
	
	
	heatmap.selectAll('rect').filter(function(d){ return d.value>=0;})
      .append('title')
      .text(function(d){
        return dayMonthFormat(d.date)+' '+numberFormatDE2(d.value)+'kWh';
      });

	renderColor();
	spinner.stop();
	  }).catch(function(error){
		  console.log("Failed to create Heatmap."+error)
	  })
	  ; //data use end
	   
	  
	 
      
	function initCalibration(){
        /*
		d3.select('[role="calibration"]').select('svg')
		.selectAll('rect').data(colorCalibration).enter()
		.append('rect')
		.attr('width',cellSize)
		.attr('height',cellSize)
		.attr('x',function(d,i){
			return i*itemSize;
		})
		.attr('fill',function(d){
			return d; 
        });
	*/
	//update values when input
	d3.select("#nValue_monday").on("input", function() {	
	threshold_monday = nValue_monday.value;
	});
	d3.select("#nValue_tuesday").on("input", function() {	
	threshold_tuesday = nValue_tuesday.value;
	});
	d3.select("#nValue_wednesday").on("input", function() {	
	threshold_wednesday = nValue_wednesday.value;
	});
	d3.select("#nValue_thursday").on("input", function() {	
	threshold_thursday = nValue_thursday.value;
	});
	d3.select("#nValue_friday").on("input", function() {	
	threshold_friday = nValue_friday.value;
	});
	d3.select("#nValue_saturday").on("input", function() {	
	threshold_saturday = nValue_saturday.value;
	});
	d3.select("#nValue_sunday").on("input", function() {	
	threshold_sunday = nValue_sunday.value;
	});
	
    //bind click event	
	/*
    d3.selectAll('[role="calibration"] [name="displayType"]').on('click',function(){	
	  renderColor();
    });
	*/
	//Updating the colors
			
  }
  

  function  writeMean(){ // use for taking average value of weekday for threshold
	      
	if(threshold_monday==0){  
	document.getElementById('nValue_monday').value=Math.round(summonday/cntmonday);
	}
	if(threshold_tuesday==0){
	document.getElementById('nValue_tuesday').value=Math.round(sumtuesday/cnttuesday);
	}
	if(threshold_wednesday==0){
	document.getElementById('nValue_wednesday').value=Math.round(sumwednesday/cntwednesday)
	}
	if(threshold_thursday==0){
	document.getElementById('nValue_thursday').value=Math.round(sumthursday/cntthursday);
	}
	if(threshold_friday==0){
	document.getElementById('nValue_friday').value=Math.round(sumfriday/cntfriday);
	}
	if(threshold_saturday==0){
	document.getElementById('nValue_saturday').value=Math.round(sumsaturday/cntsaturday);
	}
	if(threshold_sunday==0){
	document.getElementById('nValue_sunday').value=Math.round(sumsunday/cntsunday);
  	}
	
  }
  
  //extend frame height in `http://bl.ocks.org/`
  d3.select(self.frameElement).style("height", "600px");  
  }


var test2=4;

function getSankeyThresholds(Datum){
	
	var url="http://40.68.165.11/api/Messstellen/Grenzwerte/";	
	var k=1;
	while(k<=20){				
		d3.json("http://40.68.165.11/api/Messstellen/Grenzwerte/"+k+"/1").then(function(err,data){
			
			if(weekdayFormat(Datum)=='Mon'){
			sankeyThresholds.push(Number(data[0].Montag));
			}
			if(weekdayFormat(Datum)=='Tue'){
			sankeyThresholds.push(Number(data[0].Dienstag));
			}
			if(weekdayFormat(Datum)=='Wed'){
			sankeyThresholds.push(Number(data[0].Mittwoch));
			}
			if(weekdayFormat(Datum)=='Thu'){
			sankeyThresholds.push(Number(data[0].Donnerstag));
			}
			if(weekdayFormat(Datum)=='Fri'){
			sankeyThresholds.push(Number(data[0].Freitag));
			}
			if(weekdayFormat(Datum)=='Sat'){
			sankeyThresholds.push(Number(data[0].Samstag));
			}
			if(weekdayFormat(Datum)=='Sun'){
			sankeyThresholds.push(Number(data[0].Sonntag));
			}
			dataread=dataread+1;			
		});		
		k=k+1;
	}	
}

//------------------Sankey--------------//
var checkjson=null;
function fertig(){
		if(dataread<20){
			clearInterval(checkjson)
		}
		else{
			clearInterval(checkjson)
		}
}

//helper functions
function collapse(d) {
	if (d.children) {
		d._children = d.children;
		d._children.forEach(collapse);
		d.children = null;
	}
}



function expand(d) {
	if (d._children) {
		d.children = d._children;
		d.children.forEach(expand);
		d._children = null;
	}
}

var overCircle = function(d) {
	selectedNode = d;
	updateTempConnector();
};
var outCircle = function(d) {
	selectedNode = null;
	updateTempConnector();
};

// Function to update the temporary connector indicating dragging affiliation
var updateTempConnector = function() {
var data = [];
if (draggingNode !== null && selectedNode !== null) {
	// have to flip the source coordinates since we did this for the existing connectors on the original tree
	data = [{
	source: {
	x: selectedNode.y0,
	y: selectedNode.x0
	},
	target: {
	x: draggingNode.y0,
	y: draggingNode.x0
	}
	}];
}

var link = svgGroup.selectAll(".templink").data(data);

link.enter().append("path")
.attr("class", "templink")
.attr("d", d3.svg.diagonal())
.attr('pointer-events', 'none');

link.attr("d", d3.svg.diagonal());

link.exit().remove();
};

// Function to center node when clicked/dropped so node doesn't get lost when collapsing/moving with large amount of children.

function centerNode(source) {
	/*
	scale = zoomListener.scale();
	x = -source.y0;
	y = -source.x0;
	x = x * scale + ( source.name !== root.name ? viewerWidth / 2 : viewerWidth / 4 );
	y = y * scale + viewerHeight / 2;
	d3.select('g').transition()
	.duration(duration)
	.attr("transform", "translate(" + x + "," + y + ")scale(" + scale + ")");
	zoomListener.scale(scale);
	zoomListener.translate([x, y]);
	*/
}

	// Toggle children function

function toggleChildren(d) {
	if (d.children) {
		d._children = d.children;
		d.children = null;
	} else if (d._children) {
		d.children = d._children;
		d._children = null;
	}
	return d;
}

function getWebServiceIntervalSankey(day, month, year){
	var queryInterval=new Object(); 
	
	if(month==1){
		if(day==1){
			queryInterval["startyear"]=yearSelection*1-1;
			queryInterval["startmonth"]=month;
			queryInterval["startday"]=day;
			queryInterval["endyear"]=yearSelection;
			queryInterval["endmonth"]=monthSelection*1+1;
		}
		queryInterval["startyear"]=yearSelection*1-1;
		queryInterval["startmonth"]=12;
		queryInterval["endyear"]=yearSelection;
		queryInterval["endmonth"]=monthSelection*1+1;
	}
	else if(month==12){
		queryInterval["startyear"]=yearSelection;
		queryInterval["startmonth"]=monthSelection-1;
		queryInterval["endyear"]=yearSelection*1+1;
		queryInterval["endmonth"]=1;
	}
	else{
		queryInterval["startyear"]=yearSelection;
		queryInterval["startmonth"]=monthSelection*1-1;
		queryInterval["endyear"]=yearSelection;
		queryInterval["endmonth"]=monthSelection*1+1;

	}
	return queryInterval; 
}  

function addDays(date, days) {
	var result = new Date(date);
	result.setDate(result.getDate() + days);
	return result;
  }


function showsankey(Tag0, Monat0, Jahr0, DatumGW){
	dataread=0
					
	d3.selectAll('[class="overlay"]').remove();
	document.getElementById('chart').style.display = 'block';   //Sankey einblenden

	var maxscale = 1;
	// Get JSON data
	//var treeData = new Array([]); 
	//d3.json("<?php echo get_template_directory_uri(); ?>/d3_stuff/Sankey_04_live/treedata_livesankey.txt", function(sdata){
	//d3.json("http://managee2.azurewebsites.net/wp-content/mE/Postel/Postel_treedata.php", function(sdata){
	//d3.json("http://managee2.azurewebsites.net/wp-content/uploads/2015/06/treedata-demo.txt", function(sdata){
	//alert ("Daten laden");
	//var treeData = sdata;

	channelsread();


	// when the input range changes update value 
	/*
	d3.select("#nValue_mi").on("input", function() {
		var Minute = nValue_mi.value;
	});
	d3.select("#nValue_h").on("input", function() {
		var Stunde = nValue_h.value;
	});
	d3.select("#nValue_d").on("input", function() {
		var Tag = nValue_d.value;
	});
	d3.select("#nValue_m").on("input", function() {
		var Monat = nValue_m.value;
	});
	d3.select("#nValue_j").on("input", function() {
		var Jahr = nValue_j.value;
	});
	d3.select("#nValue_mi0").on("input", function() {
		var Minute0 = nValue_mi0.value;
	});
	d3.select("#nValue_h0").on("input", function() {
		var Stunde0 = nValue_h0.value;
	});
	d3.select("#nValue_d0").on("input", function() {
		var Tag0 = nValue_d0.value;
	});
	d3.select("#nValue_m0").on("input", function() {
		var Monat0 = nValue_m0.value;
	});
	d3.select("#nValue_j0").on("input", function() {
		var Jahr0 = nValue_j0.value;
	});
	*/

		
	var Minute0 = 00,
	Stunde0 = 00;
	
	
	//var Minute = 45,
	// Stunde = 23,
	var Minute = 0,
	Stunde = 0,
	Tag = Tag0+1,
	Monat = Monat0,
	Jahr =Jahr0;
		
		

	function channelsread(){
		d3.select("#update button").on("click", function() {
					update();
		});
	}

	var opts = {
		"dom": "chart svg",
		"width": 800,
		"height": 600,
		"xAxis": {
		"type": "addCategoryAxis",
		"showPercent": false 
	},
	"yAxis": {
	"type": "addMeasureAxis",
	"showPercent": false 
	},
	"zAxis": [],
	"colorAxis": [],
	"defaultColors": [],
	"layers": [],
	"legend": [],
	"nodeHeight": 50,
	"maxLabelLength": 20,
	"id": "chart svg" 
	};


	// Calculate total nodes, max label length
	var totalNodes = 0;
	var maxLabelLength = 0;
	// variables for drag/drop
	var selectedNode = null;
	var draggingNode = null;
	// panning variables
	var panSpeed = 200;
	var panBoundary = 20; // Within 20px from edges will pan when dragging.
	// Misc. variables
	var i = 0;
	var duration = 750;
	var root;
	var dataset;
	var nodedata = new Array([]);
	var nodepos = new Array([]); 
	var changedata = 0;

	// define the baseSvg, attaching a class for styling and the zoomListener
	var baseSvg = d3.select("#" + opts.id).append("svg")
	.attr("width", "100%")
	.attr("height", "100%")
	.attr("class", "overlay") ; 


	// size of the diagram
	var viewerWidth = d3.select("#" + opts.id)._groups[0][0].clientWidth;//getBoundingClientRect().width;
	var viewerHeight = d3.select("#" + opts.id)._groups[0][0].clientHeight//getBoundingClientRect().height;

	var treemap = d3.tree()
	.size([viewerHeight, viewerWidth]);

	var svgGroup = baseSvg.append("g");

	// Define the root
	root = d3.hierarchy(treeData,function(d) { return d.children; });
	console.log(root);
	//root = treeData;
	root.x0 = viewerHeight / 2;
	root.y0 = 0;
	root.children.forEach(collapse); //nur erste Ebene bei Startup anzeigen

	// Layout the tree initially and center on the root node.
	update(root);

	// define a d3 diagonal projection for use by the node paths later on.
	/*var diagonal = d3.svg.diagonal()
	.projection(function(d) {
		
	return [d.y, d.x];
	});
	*/
	function diagonal(s, d) {

		path = `M ${s.y} ${s.x}
				C ${(s.y + d.y) / 2} ${s.x},
				${(s.y + d.y) / 2} ${d.x},
				${d.y} ${d.x}`

		return path
	}

	// Call visit function to establish maxLabelLength
	visit(treeData, function(d) {
		totalNodes++;
		maxLabelLength = opts.maxLabelLength || Math.max(d.name.length, maxLabelLength);
	}, function(d) {
		return d.children && d.children.length > 0 ? d.children : null;
	});
	// sort the tree according to the node names
	function sortTree() {
		tree.sort(function(a, b) {
		return b.name.toLowerCase() < a.name.toLowerCase() ? 1 : -1;
		});
	}

	// Sort the tree initially incase the JSON isn't in a sorted order.
	//sortTree();

	// TODO: Pan function, can be better implemented.

	/*
	function pan(domNode, direction) {
	var speed = panSpeed;
	if (panTimer) {
	clearTimeout(panTimer);
	translateCoords = d3.transform(svgGroup.attr("transform"));
	if (direction == 'left' || direction == 'right') {
	translateX = direction == 'left' ? translateCoords.translate[0] + speed : translateCoords.translate[0] - speed;
	translateY = translateCoords.translate[1];
	} else if (direction == 'up' || direction == 'down') {
	translateX = translateCoords.translate[0];
	translateY = direction == 'up' ? translateCoords.translate[1] + speed : translateCoords.translate[1] - speed;
	}

	scaleX = translateCoords.scale[0];
	scaleY = translateCoords.scale[1];
	alert(scaleY);
	scale = zoomListener.scale();
	svgGroup.transition().attr("transform", "translate(" + translateX + "," + translateY + ")scale(" + scale + ")");
	d3.select(domNode).select('g.node').attr("transform", "translate(" + translateX + "," + translateY + ")");
	zoomListener.scale(zoomListener.scale());
	zoomListener.translate([translateX, translateY]);

	panTimer = setTimeout(function() {
	pan(domNode, speed, direction);
	}, 50);
	}
	}
	*/
	// Define the zoom function for the zoomable tree

	function zoom() {
		svgGroup.attr("transform", "translate(" + d3.event.translate + ")scale(" + d3.event.scale + ")");
	}


	// define the zoomListener which calls the zoom function on the "zoom" event constrained within the scaleExtents
	var zoomListener = d3.zoom().scaleExtent([0.1, 3]).on("zoom", zoom);

	function initiateDrag(d, domNode) {
		draggingNode = d;
		d3.select(domNode).select('.ghostCircle').attr('pointer-events', 'none');
		d3.selectAll('.ghostCircle').attr('class', 'ghostCircle show');
		d3.select(domNode).attr('class', 'node activeDrag');

		svgGroup.selectAll("g.node").sort(function(a, b) { // select the parent and sort the path's
			if (a.id != draggingNode.id) return 1; // a is not the hovered element, send "a" to the back
			else return -1; // a is the hovered element, bring "a" to the front
		});
		// if nodes has children, remove the links and nodes
		if (nodes.length > 1) {
		// remove link paths
			links = tree.links(nodes);
			nodePaths = svgGroup.selectAll("path.link")
			.data(links, function(d) {
				return d.target.id;
			}).remove();
		// remove child nodes
			nodesExit = svgGroup.selectAll("g.node")
			.data(nodes, function(d) {
				return d.id;
			}).filter(function(d, i) {
				if (d.id == draggingNode.id) {
					return false;
				}
				return true;
			}).remove();
		}

		// remove parent link
		parentLink = tree.links(tree.nodes(draggingNode.parent));
		svgGroup.selectAll('path.link').filter(function(d, i) {
		if (d.target.id == draggingNode.id) {
			return true;
		}
		return false;
		}).remove();
		dragStarted = null;
	}

	baseSvg	.call(zoomListener);

	/*
	// Define the drag listeners for drag/drop behaviour of nodes.
	dragListener = d3.behavior.drag()
	.on("dragstart", function(d) {
	if (d == root) {
	return;
	}
	dragStarted = true;
	nodes = tree.nodes(d);
	d3.event.sourceEvent.stopPropagation();
	// it's important that we suppress the mouseover event on the node being dragged. Otherwise it will absorb the mouseover event and the underlying node will not detect it d3.select(this).attr('pointer-events', 'none');
	})
	.on("drag", function(d) {
	if (d == root) {
	return;
	}
	if (dragStarted) {
	domNode = this;
	initiateDrag(d, domNode);
	}

	// get coords of mouseEvent relative to svg container to allow for panning
	relCoords = d3.mouse(svgGroup[0][0]);
	if (relCoords[0] < panBoundary) {
	panTimer = true;
	pan(this, 'left');
	} else if (relCoords[0] > (viewerWidth - panBoundary)) {

	panTimer = true;
	pan(this, 'right');
	} else if (relCoords[1] < panBoundary) {
	panTimer = true;
	pan(this, 'up');
	} else if (relCoords[1] > (viewerHeight - panBoundary)) {
	panTimer = true;
	pan(this, 'down');
	} else {
	try {
	clearTimeout(panTimer);
	} catch (e) {

	}
	}

	d.x0 += d3.event.dy;
	d.y0 += d3.event.dx;
	var node = d3.select(this);
	node.attr("transform", "translate(" + d.y0 + "," + d.x0 + ")");
	updateTempConnector();
	}).on("dragend", function(d) {
	if (d == root) {
	return;
	}
	domNode = this;
	if (selectedNode) {
	// now remove the element from the parent, and insert it into the new elements children
	var index = draggingNode.parent.children.indexOf(draggingNode);
	if (index > -1) {
	draggingNode.parent.children.splice(index, 1);
	}
	if (typeof selectedNode.children !== 'undefined' || typeof selectedNode._children !== 'undefined') {
	if (typeof selectedNode.children !== 'undefined') {
	selectedNode.children.push(draggingNode);
	} else {
	selectedNode._children.push(draggingNode);
	}
	} else {
	selectedNode.children = [];
	selectedNode.children.push(draggingNode);
	}
	// Make sure that the node being added to is expanded so user can see added node is correctly moved
	expand(selectedNode);
	sortTree();
	endDrag();
	} else {
	endDrag();
	}
	});

	function endDrag() {
	selectedNode = null;
	d3.selectAll('.ghostCircle').attr('class', 'ghostCircle');
	d3.select(domNode).attr('class', 'node');
	// now restore the mouseover event or we won't be able to drag a 2nd time
	d3.select(domNode).select('.ghostCircle').attr('pointer-events', '');
	updateTempConnector();
	if (draggingNode !== null) {
	update(root);
	centerNode(draggingNode);
	draggingNode = null;
	}
	}
	*/
	//buttons for expanding/collapsing the sankey tree
	d3.select("#expand button").on("click", function() {
		root.children.forEach(expand);
	});
	d3.select("#collapse button").on("click", function() {
		root.children.forEach(collapse);
	});


	// Helper functions for collapsing and expanding nodes.
	// Toggle children on click.
	function click(d) {		
		if (d3.event.defaultPrevented) return; // click suppressed
		d = toggleChildren(d);
		update(d);

	}





	function datasort2(id){
		
		var searchNode=id;	

		function checkId(treenode){
			return treenode.NodeID==searchNode;
		}

		var foundNode=dataset.find(checkId);
		return foundNode.value;
	
	}
	/*
	function datasort(channels,nodes,id,factorc,factorn,np) { // Kanäle der Daten den Nodes zuordnen
		console.log(id);
		nodes=id;
		console.log(nodes);
		var datas = 0;

		if (parseInt (channels) > 0){
		var fc = 1;
		var st_fc = factorc;
		var res_fc = st_fc.split(",");
		//alert(st_fc);
		var st_channel = channels;
		var res_channel = st_channel.split(",");
		var channel = 0;

		if ((res_fc.length == res_channel.length) && (res_fc[0] !== "")){
		for (var ifc = 0; ifc < (res_fc.length); ifc++){
		//alert (res_fc[ifc]);
		fc = parseFloat (res_fc[ifc]);
		//alert (fc);
		channel = channel + (parseFloat (dataset[res_channel[ifc]-1])*fc);
		}
		}
		else {
		fc = 1;
		for ( var i = 0; i < (res_channel.length); i++){
			channel = channel + (parseFloat (dataset[res_channel[i]-1])*fc);
		}
		}	
		if(channel < 0){  // bei negativen Werten den Wert auf 0 setzen
			channel = 0;
		}

		// for ( var i = 0; i < (res_channel.length); i++){
		// channel = channel + (parseFloat (dataset[res_channel[i]-1])*fc);
		// }
		datas = Runden2Dezimal(channel);
		nodedata[id] = datas;
		}
		if (parseInt (nodes) > 0 ) {
		var fn = 1;
		var st_fn = factorn;
		var res_fn = st_fn.split(",");

		var st_node = nodes;
		var res_node = st_node.split(",");
		var node = 0;

		if ((res_fn.length == res_node.length) && (res_fn[0] !== "")){
		for (var nfn = 0; nfn < (res_fn.length); nfn++){
		//alert (res_fc[ifc]);
		fn = parseFloat (res_fn[nfn]);
		//alert (fc);
		node = node + (parseFloat (nodedata[res_node[nfn]])*fn);
		}
		}
		else {
		fn = 1;
		for (var n = 0; n < (res_node.length); n++){
		node = node + (parseFloat (dataset[res_node[n]-1])*fn);
		}
		}
		console.log(node);
		console.log(datas);
		// for (var n = 0; n < (res_node.length); n++){
		// node = node + parseFloat (nodedata[res_node[n]]);
		// }
		datas = Runden2Dezimal(node+datas); // eventuelles Ergebnis der Kanäle aufaddieren
		nodedata[id] = datas;
		nodepos[np] = id;
		}
		//alert (datas);
		console.log(datas);
		//return 1;
		return (datas);
	}

	*/


	function Runden2Dezimal(x) { 
		Ergebnis = Math.round(x * 100) / 100 ; 
		return Ergebnis; 
	}

	tip = d3.tip()
	.attr('class', 'd3-tip')
	.offset([-5, 0])
	.html(function(d) { 
		//alert ("Tooltip"+dataset[j]);
		//var ttext = "Tooltip <br/>"+d.Tooltip; 
		return d.Tooltip; 
	});	
	baseSvg.call(tip);

	function update(source) {
	// Compute the new height, function counts total children of root node and sets tree height accordingly.
	// This prevents the layout looking squashed when new nodes are made visible or looking sparse when nodes are removed
	// This makes the layout more consistent.

		/*
		Minute = nValue_mi.value;
		Stunde = nValue_h.value;
		Tag = nValue_d.value;
		Monat = nValue_m.value;
		Jahr = nValue_j.value;
		Minute0 = nValue_mi0.value;
		Stunde0 = nValue_h0.value;
		Tag0 = nValue_d0.value;
		Monat0 = nValue_m0.value;
		Jahr0 = nValue_j0.value;
		*/
		//console.log("test: "+new Date(Jahr0,Monat0,Tag0));
		Datum = Tag+"."+Monat+"."+Jahr;
		Datum0 = Tag0+"."+Monat0+"."+Jahr0;

		var dob = new Date();
		var zonedif = dob.getTimezoneOffset();
		//console.log(dob + " ::: " + zonedif);
		
		console.log(" jahr0: "+Jahr0+" monat0: "+Monat0+" tag0: "+Tag0);
		console.log(" jahr: "+Jahr+" monat: "+Monat+" tag: "+Tag);
		var tzone = d3.timeFormat('%Z')(new Date());
		var toffset = tzone * 36;
		//console.log(toffset);
		//var time0 = new Date(Jahr0+'-'+Monat0+'-'+Tag0);
		//var time = new Date(Jahr+'-'+Monat+'-'+Tag);
		var time0 = new Date(Jahr0,Monat0-1,Tag0);
		var time = new Date(Jahr,Monat-1,Tag);	
		console.log(" time0: "+time0+ " time: "+time);
		time0 = (time0.getTime()/1000+toffset);
		time = (time.getTime()/1000+toffset);
		timediff = time - time0;
		console.log("berechnung timediff: "+timediff+" time0: "+time0+ " time: "+time);
		
		var time3 = new Date(Jahr0,Monat0-1,Tag0,Stunde0,Minute0);
		time3 = ((time3.getTime()/1000)+zonedif*60);     // neues Datum zur UTC Datenbankabfrage
		//console.log ("altdate "+time3*1000);
		var neudate3 = new Date(time3*1000);
		var jahr3 = neudate3.getFullYear();
		var monat3 = neudate3.getMonth()+1;
		var tag3 = neudate3.getDate();
		var stunden3 = neudate3.getHours();
		//console.log ("neudate "+neudate3);
		//console.log ("jahr3: "+ jahr3+" Monat3: "+ monat3+" Tag3: "+ tag3+" Stunde3: "+ stunden3);
		var Datum3 = tag3+"."+monat3+"."+jahr3+" "+stunden3+":"+Minute0+":00";
		//console.log("Datum3: "+Datum3+ " h3: "+stunden3);
		
		
		var time4 = new Date(Jahr,Monat-1,Tag,Stunde,Minute);
		time4 = ((time4.getTime()/1000)+zonedif*60);     // neues Datum zur UTC Datenbankabfrage
		var neudate4 = new Date(time4*1000);
		var jahr4 = neudate4.getFullYear();
		var monat4 = neudate4.getMonth()+1;
		var tag4 = neudate4.getDate();
		var stunden4 = neudate4.getHours();
		var Datum4 = tag4+"."+monat4+"."+jahr4+" "+stunden4+":"+Minute+":00";
		//console.log("Datum4: "+Datum4+ " h4: "+stunden4);
		
		var datediv = document.getElementById("Datum");  
		datediv.textContent = Tag0+"."+Monat0+"."+Jahr0;
	

		phpoffset = -zonedif/60;






		changedata = changedata + 1; // sich ändernde Daten an den php Aufruf schicken, damit der Internetexplorer nicht cached
		if (changedata > 100){
			changedata = 0;
		}

		var string = "?time1="+Datum3+"&time2="+Datum4;
		var startdate=new Date(Jahr0,(Monat0*1-1),Tag0,0,0);

		var enddate=addDays(startdate,1); 
		console.log(startdate+"  "+ enddate);
		var startstring=urlformatsankey(startdate)+"0000";
		var endstring=urlformatsankey(enddate)+"0000";
		console.log(startstring+" "+endstring)
		/*
		var startstring=Jahr0.toString()+Monat0.toString().padStart(2,'0').Tag0.toString().padStart(2,'0');
		var endstring=Jahr0.toString()+Monat0.toString().padStart(2,'0').Tag0.toString().padStart(2,'0');
		*/

		console.log(mainlink+"/kWhSankey/"+blog_id.toString()+"/"+startstring+"/"+endstring+codestring);
		//d3.json("http://managee2.azurewebsites.net/wp-content/mE/Postel/Postel_kwh_abfrage.php"+string, function(daten){
		//d3.json("http://managee2.azurewebsites.net/wp-content/themes/twentyfourteen_mE_ipTro/d3_stuff/Heatmap/postel_kwh_Abfrage.php"+string, function(daten){
		d3.json(mainlink+"/kWhSankey/"+blog_id.toString()+"/"+startstring+"/"+endstring+codestring).then(function(daten){  
		//d3.json("http://managee2.azurewebsites.net/wp-content/mE/heatmap/heatmap_sankey_kwh.php"+string).then(function(daten){  
			
			//alert ("Daten laden");
			dataset = daten;
			console.log(dataset);
			var levelWidth = [1];

			var childCount = function(level, n) {
				if (n.children && n.children.length > 0) {
					if (levelWidth.length <= level + 1) levelWidth.push(0);

					levelWidth[level + 1] += n.children.length;
					n.children.forEach(function(d) {
						childCount(level + 1, d);
					});
				}
			};

			childCount(0, root);
			var newHeight = d3.max(levelWidth) * ( opts.nodeHeight || 25 ); // 25 pixels per line 

			//tree = tree.size([newHeight, viewerWidth]);
			var treeData=treemap(root);
			// Compute the new tree layout.
			var nodes = treeData.descendants();//tree.nodes(root).reverse(),
			links = treeData.descendants().slice(1);//root.links(nodes);

			// Set widths between levels based on maxLabelLength.
			nodes.forEach(function(d) {
			d.y = (d.depth * (maxLabelLength * 10)); //maxLabelLength * 10px
			// alternatively to keep a fixed scale one can set a fixed depth per level
			// Normalize for fixed-depth by commenting out below line
			// d.y = (d.depth * 500); //500px per level.
			});

			// Update the nodes…
			var node = svgGroup.selectAll("g.node")
			.data(nodes, function(d) {
				console.log(d.data.name+"  "+d.data.NodeID+"  "+d.NodeID);
			return d.data.NodeID;// || (d.id = ++i);
			});

			// Enter any new nodes at the parent's previous position.
			var nodeEnter = node.enter().append("g")
			// .call(dragListener)
			.attr("class", "node")
			.attr("transform", function(d) {
			return "translate(" + source.y0 + "," + source.x0 + ")";
			})
			.on('click', click);
			// .on('mouseover', tip.show)
			// .on('mouseout', tip.hide);

			nodeEnter.append("circle")
			.attr('class', 'nodeCircle')
			.attr("r", 0)
			.style("fill", function(d) {
				return d._children ? "lightsteelblue" : "#fff";
			});

			nodeEnter.append("text")
			.attr("x", function(d) {
				return d.children || d._children ? -10 : 10;
			})
			.attr("dy", ".35em")
			.attr('class', 'nodeText')
			.attr("text-anchor", function(d) {
				return d.children || d._children ? "end" : "start";
			})
			.text(function(d) {
				return d.data.name;
			})
			.style("fill-opacity", 0);

			// phantom node to give us mouseover in a radius around it
			nodeEnter.append("circle")
			.attr('class', 'ghostCircle')
			.attr("r", 30)
			.attr("opacity", 0.2) // change this to zero to hide the target area
			.style("fill", "red")
			.attr('pointer-events', 'mouseover')
			.on("mouseover", function(node) {
				overCircle(node);
			})
			.on("mouseout", function(node) {
				outCircle(node);
			});

			// Update the text to reflect whether node has children or not.
			node.select('text')
			.attr("x", function(d) {
				return d.children || d._children ? -10 : 10;
			})
			.attr("text-anchor", function(d) {
				return d.children || d._children ? "end" : "start";
			})
			.text(function(d,j) {
			//return d.name+": "+j+" Node:"+d.NodeID+" "+dataset[d.NodeID-1]+"W";
			//return d.name+": NodeID:"+d.NodeID+"---- "+datasort(d.channel,d.node,d.NodeID,d.factorc,d.factorn,j)+"W";
				//return d.data.name+" - "+datasort(d.data.channel,d.data.node,d.data.NodeID,d.data.factorc,d.data.factorn,j)+"kWh";
				return d.data.name+" - "+datasort2(d.data.NodeID)+"kWh";
			})
			//.on('mouseover', tip.show)   Tooltip einblenden
			//.on('mouseout', tip.hide);

			// Change the circle fill depending on whether it has children and is collapsed
			node.select("circle.nodeCircle")
			//.attr("r", 4.5)
			.attr("r",function(d,j) {
				//var dataradi = datasort(d.data.channel,d.data.node,d.data.NodeID,d.data.factorc,d.data.factorn,j);
				var dataradi = datasort2(d.data.NodeID);
				console.log(dataradi);
				if (dataradi > maxscale){
					maxscale = dataradi;
				}
				var radi = ((100/maxscale)*dataradi)*(12/100);
				// console.log("1: "+radi);
				if (radi>12){
					radi = 12;
				}
				if (radi<3){
					radi = 3;
				}
				// console.log("2: "+radi);
				return radi;
			})
			.style("fill", function(d) {
				return d._children ? "lightsteelblue" : "#fff";
			});

			// Transition nodes to their new position.
			var nodeUpdate = node.transition()
			.duration(duration)
			.attr("transform", function(d) {
				return "translate(" + d.y + "," + d.x + ")";
			});

			// Fade the text in
			nodeUpdate.select("text")
			.style("fill-opacity", 1);

			// Transition exiting nodes to the parent's new position.
			var nodeExit = node.exit().transition()
			.duration(duration)
			.attr("transform", function(d) {
				return "translate(" + source.y + "," + source.x + ")";
			})
			.remove();

			nodeExit.select("circle")
			.attr("r", 0);

			nodeExit.select("text")
			.style("fill-opacity", 0);

			var link = svgGroup.selectAll('path.link')
			.data(links, function(d) { return d.id; });

			// Update the links…
			/*
			var link = svgGroup.selectAll("path.link")
			.data(links, function(d) {
			return d.target.id;
			});
			*/
			// Enter any new links at the parent's previous position.
			var linkEnter = link.enter().insert('path', "g")
			.attr("class", "link")
			.attr('d', function(d){
				var o = {x: source.x0, y: source.y0}
				return diagonal(o, o)
			});

			//var linkUpdate=linkEnter.merge(link);

			// Size link width according to n based on total n
			wscale = d3.scaleLinear()
			.range([0,50])
			.domain([0,25]);

			//color nodes with higher values then threshold for channel
			/*
			if(dataread<20){
				fertig();
			}
			*/
			
			link.style("stroke",function(d){    // Strichfarbe
				var col;		
				col = "#000080";
				return col;
			}); 


			link.style("stroke-width",function(d,j){
				//var datascale = datasort(d.data.channel,d.data.node,d.data.NodeID,d.data.factorc,d.data.factorn,j);
				var datascale = datasort2(d.data.NodeID);
				if (datascale > maxscale){
					maxscale = datascale;
				}
				linescale = ((100/maxscale)*datascale)*(15/100);
							if (linescale > 15 ){ linescale = 15};
							if (linescale < 1 ){ linescale = 1};
				return 10;
			});

			// Transition links to their new position.
			link.transition()
			.duration(duration)
			.attr("d", diagonal);
			// Transition exiting nodes to the parent's new position.
			var linkExit = link.exit().transition()
			.duration(duration)
			.attr('d', function(d) {
				var o = {x: source.x, y: source.y}
				return diagonal(o, o)
			})
			.remove();
			// Stash the old positions for transition.
			nodes.forEach(function(d) {
			d.x0 = d.x;
			d.y0 = d.y;
			});
		});
	}


	// Append a group which holds all nodes and which the zoom Listener can act upon.

	//alert ("update");
	// since we can override node height and label length (width)
	// if zoom scale == 1 then auto scale to fit tree in container
	/*
	if (zoomListener.scale() == 1) {
	zoomListener.scale( viewerHeight/tree.size()[0] );
	}
	*/
	//centerNode(root);
	console.log(totalNodes);
	//});
	//function updateMeasurements(){
	//update(root);
	//}
	//updateMeasurements();
	//setInterval(updateMeasurements, 1000);
	//});//end sankey function
	console.log(treeData);
}